import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkGoodsCategory, ThinkGoodsCategoryParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkGoodsCategory(params: ThinkGoodsCategoryParam) {
  const res = await request.get<ApiResult<PageResult<ThinkGoodsCategory>>>(
    THINK_API_URL + '/think/think-goods-category/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkGoodsCategory(params?: ThinkGoodsCategoryParam) {
  const res = await request.get<ApiResult<ThinkGoodsCategory[]>>(
    THINK_API_URL + '/think/think-goods-category',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkGoodsCategory(data: ThinkGoodsCategory) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkGoodsCategory(data: ThinkGoodsCategory) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkGoodsCategory(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-category/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkGoodsCategory(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-category/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkGoodsCategory(id: number) {
  const res = await request.get<ApiResult<ThinkGoodsCategory>>(
    THINK_API_URL + '/think/think-goods-category/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
